diff --git a/base/symkey/src/com/netscape/symkey/SymKey.cpp b/base/symkey/src/com/netscape/symkey/SymKey.cpp
index 6e206db..44567f9 100644
--- a/base/symkey/src/com/netscape/symkey/SymKey.cpp
+++ b/base/symkey/src/com/netscape/symkey/SymKey.cpp
@@ -91,6 +91,8 @@ char masterKeyNickName[KEYNAMELENGTH];
 char masterNewKeyNickName[KEYNAMELENGTH];
 char sharedSecretSymKeyName[KEYNAMELENGTH] = { 0 };
 
+static int checkForDeveloperKeySet(char * keyInfo);
+
 //=================================================================================
 #ifdef __cplusplus
 extern "C"
@@ -509,10 +511,10 @@ static secuPWData pwdata = { secuPWData::PW_NONE, 0 };
  * Internal token is required when we are doing key diversification
  * where raw key material needs to be accessed
  */
-PK11SymKey *ComputeCardKeyOnSoftToken(PK11SymKey *masterKey, unsigned char *data)
+PK11SymKey *ComputeCardKeyOnSoftToken(PK11SymKey *masterKey, unsigned char *data, int protocol)
 {
     PK11SlotInfo *slot = PK11_GetInternalKeySlot();
-    PK11SymKey *key = ComputeCardKey(masterKey, data, slot);
+    PK11SymKey *key = ComputeCardKey(masterKey, data, slot,protocol);
     if( slot != NULL) {
         PK11_FreeSlot(slot);
         slot = NULL;
@@ -521,7 +523,7 @@ PK11SymKey *ComputeCardKeyOnSoftToken(PK11SymKey *masterKey, unsigned char *data
     return key;
 }
 
-PK11SymKey *ComputeCardKey(PK11SymKey *masterKey, unsigned char *data, PK11SlotInfo *slot)
+PK11SymKey *ComputeCardKey(PK11SymKey *masterKey, unsigned char *data, PK11SlotInfo *slot,int protocol)
 {
     PK11SymKey *key = NULL;
     PK11Context *context = NULL;
@@ -533,9 +535,12 @@ PK11SymKey *ComputeCardKey(PK11SymKey *masterKey, unsigned char *data, PK11SlotI
     static SECItem noParams = { siBuffer, NULL, 0 };
     unsigned char *in = data;
     PK11SymKey *tmpkey = NULL;
+    unsigned char icv[EIGHT_BYTES] = { 0 };
     unsigned char wrappedkey[DES3_LENGTH];
     SECItem wrappeditem = { siBuffer, NULL, 0 };
 
+    PR_fprintf(PR_STDOUT,"ComputeCardKey: protocol %d.\n",protocol);
+
     keyData = (unsigned char*)malloc(keysize);
 
     for (i = 0;i < keysize; i++)
@@ -550,7 +555,7 @@ PK11SymKey *ComputeCardKey(PK11SymKey *masterKey, unsigned char *data, PK11SlotI
 
     context = PK11_CreateContextBySymKey(CKM_DES3_ECB, CKA_ENCRYPT,
         masterKey,
-        &noParams);
+        &noParams); 
 
     if (context == NULL) {
         PR_fprintf(PR_STDERR,"ComputeCardKey: failed to create context.\n");
@@ -591,7 +596,7 @@ PK11SymKey *ComputeCardKey(PK11SymKey *masterKey, unsigned char *data, PK11SlotI
         PR_fprintf(PR_STDERR,"ComputeCardKey: failed to keygen. \n");
         goto done;
     }
-  
+
     context = PK11_CreateContextBySymKey(CKM_DES3_ECB, CKA_ENCRYPT,
         tmpkey,
         &noParams);
@@ -635,10 +640,10 @@ done:
     return key;
 }
 
-PK11SymKey * ComputeCardKeyOnToken(PK11SymKey *masterKey, BYTE* data)
+PK11SymKey * ComputeCardKeyOnToken(PK11SymKey *masterKey, BYTE* data, int protocol)
 {
     PK11SlotInfo *slot = PK11_GetSlotFromKey(masterKey);
-    PK11SymKey *key = ComputeCardKey(masterKey, data, slot);
+    PK11SymKey *key = ComputeCardKey(masterKey, data, slot,protocol);
 
     if( slot) {
         PK11_FreeSlot(slot);
@@ -787,13 +792,14 @@ PRStatus ComputeKeyCheckWithSymKey(PK11SymKey * newKey, Buffer& output)
 }
 
 // Create key set data with the help of either a provided old_keyk_ke2_sym key or key buffer (for the Default keyset case).
-PRStatus CreateKeySetDataWithSymKeys( Buffer &newMasterVer,const Buffer &old_kek_key2, PK11SymKey *old_kek_key2_sym, PK11SymKey *new_auth_key, PK11SymKey *new_mac_key, PK11SymKey *new_kek_key, Buffer &output)
+PRStatus CreateKeySetDataWithSymKeys( Buffer &newMasterVer,const Buffer &old_kek_key2, PK11SymKey *old_kek_key2_sym, PK11SymKey *new_auth_key, PK11SymKey *new_mac_key, PK11SymKey *new_kek_key,int protocol, Buffer &output)
 {
     PRStatus rv = PR_FAILURE;
     static SECItem noParams = { siBuffer, NULL, 0 };
     PK11SymKey *transportKey = NULL;
     PK11SymKey *wrappingKey = NULL;
     BYTE masterKeyData[DES3_LENGTH];
+    BYTE alg = 0x81;
 
     /* Wrapping vars */
     SECItem wrappedKeyItem   = { siBuffer, NULL , 0 };
@@ -819,34 +825,69 @@ PRStatus CreateKeySetDataWithSymKeys( Buffer &newMasterVer,const Buffer &old_kek
     Buffer kc_kek_key(3);
     Buffer result;
 
-    PR_fprintf(PR_STDOUT,"In CreateKeySetDataWithSymKeys!\n");
+    //Buffer *dumpBuffer = NULL;
+    //int showDerivedKeys = 0;
+
+    PR_fprintf(PR_STDOUT,"In CreateKeySetDataWithSymKeys! Protocol: %d \n",protocol);
 
     if ( new_auth_key == NULL || new_mac_key == NULL || new_kek_key == NULL) {
         return rv;
     }
 
     slot = PK11_GetSlotFromKey(new_auth_key);
-    if ( old_kek_key2_sym == NULL ) { /* perm key mode */
-        /* Find transport key, shared secret */
-        transportKey = ReturnSymKey( slot, GetSharedSecretKeyName(NULL));
-        if ( transportKey == NULL ) {
-            goto done;
+
+    if(protocol == 1) {
+        if ( old_kek_key2_sym == NULL ) { /* perm key mode */
+            /* Find transport key, shared secret */
+            transportKey = ReturnSymKey( slot, GetSharedSecretKeyName(NULL));
+            if ( transportKey == NULL ) {
+                goto done;
+            }
+
+            /* convert 16-byte to 24-byte triple-DES key */
+            memcpy(masterKeyData, old_kek_key2, KEYLENGTH);
+            memcpy(masterKeyData+16, old_kek_key2, EIGHT_BYTES);
+
+            wrappingKey = CreateUnWrappedSymKeyOnToken( slot, transportKey,  masterKeyData, sizeof(masterKeyData), PR_FALSE);
+
+        } else { /* card key mode */
+            PR_fprintf(PR_STDOUT,"In CreateKeySetDataWithSymKeys: SCP01 card key mode.\n");
+            wrappingKey = old_kek_key2_sym;
         }
 
-        /* convert 16-byte to 24-byte triple-DES key */
-        memcpy(masterKeyData, old_kek_key2, KEYLENGTH);
-        memcpy(masterKeyData+16, old_kek_key2, EIGHT_BYTES);
+   } else if(protocol == 2) {
 
-        wrappingKey = CreateUnWrappedSymKeyOnToken( slot, transportKey,  masterKeyData, sizeof(masterKeyData), PR_FALSE);
+       PR_fprintf(PR_STDOUT,"In CreateKeySetDataWithSymKeys: Using dekKey from SCP02 for wrapping key.\n");
 
-    } else { /* card key mode */
-        wrappingKey = old_kek_key2_sym;
-    }
+
+       // Use the unwapped SCP02 DEK sym key pointer. 
+       wrappingKey = old_kek_key2_sym;
+
+   } else {
+       PR_fprintf(PR_STDERR,"Invalid protocol %d . \n",protocol);
+            goto done;
+
+   }
 
         //Now derive 16 byte versions of the provided symkeys
         authKey16 = PK11_Derive(new_auth_key, CKM_EXTRACT_KEY_FROM_KEY, &paramsItem, CKA_ENCRYPT,
                                                             CKA_DERIVE, 16);
 
+        /*
+
+        if(showDerivedKeys == 1) {
+            SECItem *keyData = NULL;
+            PK11_ExtractKeyValue( authKey16 ); 
+            keyData = PK11_GetKeyData(authKey16);
+            dumpBuffer = new Buffer(keyData->data,keyData->len  );
+            PR_fprintf(PR_STDERR,"Debug authKey16 data: \n");
+            dumpBuffer->dump();
+            delete dumpBuffer;
+            dumpBuffer = NULL;
+        }
+
+        */
+
         if ( authKey16 == NULL ) {
             PR_fprintf(PR_STDERR,"Error deriving authKey16. Error %d \n", PR_GetError());
             goto done;
@@ -860,13 +901,28 @@ PRStatus CreateKeySetDataWithSymKeys( Buffer &newMasterVer,const Buffer &old_kek
             goto done;
         }
 
-         macKey16 = PK11_Derive(new_mac_key, CKM_EXTRACT_KEY_FROM_KEY, &paramsItem, CKA_ENCRYPT, CKA_DERIVE, 16);
+        macKey16 = PK11_Derive(new_mac_key, CKM_EXTRACT_KEY_FROM_KEY, &paramsItem, CKA_ENCRYPT, CKA_DERIVE, 16);
 
         if ( macKey16 == NULL ) {
             PR_fprintf(PR_STDERR,"Error deriving macKey16. Error %d \n", PR_GetError());
             goto done;
         }
 
+        /*
+
+        if(showDerivedKeys == 1) {
+            SECItem *keyData = NULL;
+            PK11_ExtractKeyValue( macKey16 );
+            keyData = PK11_GetKeyData(macKey16);
+            dumpBuffer = new Buffer(keyData->data,keyData->len  );
+            PR_fprintf(PR_STDERR,"Debug macKey16 data: \n");
+            dumpBuffer->dump();
+            delete dumpBuffer;
+            dumpBuffer = NULL;
+        }
+
+        */
+
         wrappedKeyItem.data = (unsigned char *) encrypted_mac_key;
         wrappedKeyItem.len  = encrypted_mac_key.size();
         wrapStatus = PK11_WrapSymKey(CKM_DES3_ECB,&noParams, wrappingKey, macKey16, &wrappedKeyItem);
@@ -883,6 +939,21 @@ PRStatus CreateKeySetDataWithSymKeys( Buffer &newMasterVer,const Buffer &old_kek
             PR_fprintf(PR_STDERR,"Error deriving kekKey16. Error %d \n", PR_GetError());
         }
 
+        /*
+
+        if(showDerivedKeys == 1) {
+            SECItem *keyData = NULL;
+            PK11_ExtractKeyValue( kekKey16 );
+            keyData = PK11_GetKeyData(kekKey16);
+            dumpBuffer = new Buffer(keyData->data,keyData->len  );
+            PR_fprintf(PR_STDERR,"Debug kekKey16 data: \n");
+            dumpBuffer->dump();
+            delete dumpBuffer;
+            dumpBuffer = NULL;
+        }
+   
+        */
+
         wrappedKeyItem.data = (unsigned char *) encrypted_kek_key;
         wrappedKeyItem.len  = encrypted_mac_key.size();
         wrapStatus = PK11_WrapSymKey(CKM_DES3_ECB,&noParams, wrappingKey, kekKey16, &wrappedKeyItem);
@@ -897,18 +968,22 @@ PRStatus CreateKeySetDataWithSymKeys( Buffer &newMasterVer,const Buffer &old_kek
 
         ComputeKeyCheckWithSymKey(new_kek_key, kc_kek_key);
 
+        if(protocol == 2) {
+            alg = 0x80;
+        } //default at top is 0x81
+
         result = newMasterVer +
-            Buffer(1, (BYTE)0x81) +
+            Buffer(1, (BYTE)alg) +
             Buffer(1, (BYTE)0x10) +
             encrypted_auth_key +
             Buffer(1, (BYTE)0x03) +
             kc_auth_key +
-            Buffer(1, (BYTE)0x81) +
+            Buffer(1, (BYTE)alg) +
             Buffer(1, (BYTE)0x10) +
             encrypted_mac_key +
             Buffer(1, (BYTE)0x03) +
             kc_mac_key +
-            Buffer(1, (BYTE)0x81) +
+            Buffer(1, (BYTE)alg) +
             Buffer(1, (BYTE)0x10) +
             encrypted_kek_key +
             Buffer(1, (BYTE)0x03) +
@@ -1042,13 +1117,13 @@ void getFullName(char * fullMasterKeyName, char * masterKeyNameChars )
 // AC: KDF SPEC CHANGE: function signature change - added jstring oldKeyInfo, jbyte nistSP800_108KdfOnKeyVersion, jboolean nistSP800_108KdfUseCuidAsKdd, and jbyteArray KDD
 // AC: BUGFIX for key versions higher than 09:  We need to specialDecode keyInfo parameters before sending them into symkey!  This means the parameters must be jbyteArray's
 //     -- Changed parameter "jstring keyInfo" to "jbyteArray newKeyInfo"
-extern "C" JNIEXPORT jbyteArray JNICALL Java_com_netscape_symkey_SessionKey_DiversifyKey
-(JNIEnv *, jclass, jstring, jstring, jstring, jstring, jbyteArray, jbyteArray, jbyte, jboolean, jbyteArray, jbyteArray, jbyteArray, jstring, jstring);
+//extern "C" JNIEXPORT jbyteArray JNICALL Java_com_netscape_symkey_SessionKey_DiversifyKey
+//(JNIEnv *, jclass, jstring, jstring, jstring, jstring, jbyteArray, jbyteArray, jbyte, jboolean, jbyteArray, jbyteArray, jbyteArray, jstring, jstring);
 
 // AC: KDF SPEC CHANGE: function signature change - added jstring oldKeyInfo, jbyte nistSP800_108KdfOnKeyVersion, jboolean nistSP800_108KdfUseCuidAsKdd, and jbyteArray KDD
 // AC: BUGFIX for key versions higher than 09:  We need to specialDecode keyInfo parameters before sending them into symkey!  This means the parameters must be jbyteArray's
 //     -- Changed parameter "jstring keyInfo" to "jbyteArray newKeyInfo"
-extern "C" JNIEXPORT jbyteArray JNICALL Java_com_netscape_symkey_SessionKey_DiversifyKey( JNIEnv * env, jclass this2, jstring tokenName,jstring newTokenName, jstring oldMasterKeyName, jstring newMasterKeyName, jbyteArray oldKeyInfo, jbyteArray newKeyInfo, jbyte nistSP800_108KdfOnKeyVersion, jboolean nistSP800_108KdfUseCuidAsKdd, jbyteArray CUIDValue, jbyteArray KDD, jbyteArray kekKeyArray, jstring useSoftToken_s, jstring keySet)
+extern "C" JNIEXPORT jbyteArray JNICALL Java_com_netscape_symkey_SessionKey_DiversifyKey( JNIEnv * env, jclass this2, jstring tokenName,jstring newTokenName, jstring oldMasterKeyName, jstring newMasterKeyName, jbyteArray oldKeyInfo, jbyteArray newKeyInfo, jbyte nistSP800_108KdfOnKeyVersion, jboolean nistSP800_108KdfUseCuidAsKdd, jbyteArray CUIDValue, jbyteArray KDD, jbyteArray kekKeyArray, jstring useSoftToken_s, jstring keySet,jbyte protocol)
 {
     PK11SymKey *encKey = NULL;
     PK11SymKey *macKey = NULL;
@@ -1069,6 +1144,7 @@ extern "C" JNIEXPORT jbyteArray JNICALL Java_com_netscape_symkey_SessionKey_Dive
     PK11SymKey* old_mac_sym_key = NULL;
     PK11SymKey* old_enc_sym_key = NULL;
     PK11SymKey* old_kek_sym_key = NULL;
+    BYTE scp02DekKeyData[DES3_LENGTH];
 
     char *keySetStringChars =  NULL;
     if ( keySet != NULL ) {
@@ -1106,10 +1182,10 @@ extern "C" JNIEXPORT jbyteArray JNICALL Java_com_netscape_symkey_SessionKey_Dive
     Buffer output;
     PK11SlotInfo *newSlot =NULL;
     char * newTokenNameChars = NULL;
-    char *keyInfoChars = NULL;
+    //char *keyInfoChars = NULL;
 
     // AC: KDF SPEC CHANGE:  Need to retrieve old key info from JNI.
-    char* oldKeyInfoChars = NULL;
+    //char* oldKeyInfoChars = NULL;
 
     // AC: KDF SPEC CHANGE:  Convert new setting value to BYTE (unsigned).
     BYTE nistSP800_108KdfOnKeyVersion_byte = static_cast<BYTE>(nistSP800_108KdfOnKeyVersion);
@@ -1125,6 +1201,7 @@ extern "C" JNIEXPORT jbyteArray JNICALL Java_com_netscape_symkey_SessionKey_Dive
 
     PK11SymKey * masterKey = NULL;
     PK11SymKey * oldMasterKey = NULL;
+    PK11SymKey * transportKey = NULL;
 
     BYTE KDCenc[KEYLENGTH];
     BYTE KDCmac[KEYLENGTH];
@@ -1170,7 +1247,7 @@ extern "C" JNIEXPORT jbyteArray JNICALL Java_com_netscape_symkey_SessionKey_Dive
         goto done;
     }
 
-    PR_fprintf(PR_STDOUT,"In SessionKey.DiversifyKey! \n");
+    PR_fprintf(PR_STDOUT,"In SessionKey.DiversifyKey! Protocol: %d \n", protocol);
 
     // AC: KDF SPEC CHANGE:
     // Changed from "cuidValue" to "kddValue".
@@ -1274,106 +1351,103 @@ extern "C" JNIEXPORT jbyteArray JNICALL Java_com_netscape_symkey_SessionKey_Dive
     if(newSlot == NULL) {
         newSlot = slot;
     }
-    if(strcmp( oldMasterKeyNameChars, "#01#01") == 0 || strcmp( oldMasterKeyNameChars, "#FF#01") == 0)
-    {
-        old_kek_key_buff    =   Buffer((BYTE*)old_kek_key, KEYLENGTH);
 
+    if(protocol == 1) {
+        if( checkForDeveloperKeySet(oldMasterKeyNameChars ))
+        {
+            old_kek_key_buff    =   Buffer((BYTE*)old_kek_key, KEYLENGTH);
+        }
+        else
+        {
+            oldMasterKey =     ReturnSymKey(slot,fullMasterKeyName);
 
-    // AC: BUGFIX: Remove garbage code.
-    //             I believe that this code is a no-op as long as the system is working correctly
-    //             (with the developer keyset data populated in the config file & copied to HSM).
-    //
-    //             Notes:
-    //               "old_kek_key_buff" appears to only be used if unable to read/load the developer keys into HSM.
-    //               "old_kek_key_buff" is populated with incorrect data (not appropriate key-length)
-    //               "output" is overwritten when "CreateKeySetDataWithSymKeys" is called
-    //
-    //             As a result, only when there is some failure (i.e. we execute a "goto" and skip assignment
-    //               to "output") do we return a keyset data that is 16 bytes in length (the default KEK).
-    //               This is unlikely to work and even if it does, is a horrible idea as the caller has no way
-    //               of knowing that we've now essentially inserted a "backdoor" on the token.  So, instead of
-    //               this, we treat #00#00 just like any other "normal" case.
-    //
-    //}else if(strcmp( oldMasterKeyNameChars, "#00#00") == 0)
-    //{
-    //    /* print Debug message - do not create real keysetdata */
-    //    old_kek_key_buff    =       Buffer((BYTE*)"#00#00", 6);
-    //    output              =       Buffer((BYTE*)old_kek_key, KEYLENGTH);
 
+            // AC: BUGFIX: Check for nonexistent master key instead of (potentially) crashing.
+            if (oldMasterKey == NULL){
+                goto done;
+            }
 
-    }
-    else
-    {
-        oldMasterKey =     ReturnSymKey(slot,fullMasterKeyName);
 
+            // ---------------------------------
+            // AC KDF SPEC CHANGE: Determine which KDF to use.
+            //
+            // if old key version meets setting value, use NIST SP800-108 KDF for deriving old keys
+            if (NistSP800_108KDF::useNistSP800_108KDF(nistSP800_108KdfOnKeyVersion_byte, oldKeyVersion) == true){
 
-        // AC: BUGFIX: Check for nonexistent master key instead of (potentially) crashing.
-        if (oldMasterKey == NULL){
-            goto done;
-        }
+                PR_fprintf(PR_STDOUT,"DiversifyKey old key NistSP800_108KDF code: Using NIST SP800-108 KDF for old keyset.\n");
 
+                // react to "UseCUIDAsKDD" setting value
+                jbyte* context_jbyte = NULL;
+                jsize context_len_jsize = 0;
+                if (nistSP800_108KdfUseCuidAsKdd == JNI_TRUE){
+                    context_jbyte = cuidValue;
+                    context_len_jsize = cuidValue_len;
+                }else{
+                    context_jbyte = kddValue;
+                    context_len_jsize = kddValue_len;
+                }
 
-        // ---------------------------------
-        // AC KDF SPEC CHANGE: Determine which KDF to use.
-        //
-        // if old key version meets setting value, use NIST SP800-108 KDF for deriving old keys
-        if (NistSP800_108KDF::useNistSP800_108KDF(nistSP800_108KdfOnKeyVersion_byte, oldKeyVersion) == true){
+                // Converting this way is safe since jbyte is guaranteed to be 8 bits
+                // Of course, this assumes that "char" is 8 bits (not guaranteed, but typical),
+                //            but it looks like this assumption is also made in GetDiversificationData
+                const BYTE* const context = reinterpret_cast<const BYTE*>(context_jbyte);
 
-            PR_fprintf(PR_STDOUT,"DiversifyKey old key NistSP800_108KDF code: Using NIST SP800-108 KDF for old keyset.\n");
+                // Convert jsize to size_t
+                const size_t context_len = static_cast<size_t>(context_len_jsize);
+                if (context_len > 0x000000FF){  // sanity check (CUID should never be larger than 255 bytes)
+                    PR_fprintf(PR_STDERR, "DiversifyKey old key NistSP800_108KDF code: Error; context_len larger than 255 bytes.\n");
+                    goto done;
+                }
 
-            // react to "UseCUIDAsKDD" setting value
-            jbyte* context_jbyte = NULL;
-            jsize context_len_jsize = 0;
-            if (nistSP800_108KdfUseCuidAsKdd == JNI_TRUE){
-                context_jbyte = cuidValue;
-                context_len_jsize = cuidValue_len;
+                // call NIST SP800-108 KDF routine
+                try{
+                    NistSP800_108KDF::ComputeCardKeys(oldMasterKey, context, context_len, &old_enc_sym_key, &old_mac_sym_key, &old_kek_sym_key);
+                }catch(std::runtime_error& ex){
+                    PR_fprintf(PR_STDERR, "DiversifyKey old key NistSP800_108KDF code: Exception invoking NistSP800_108KDF::ComputeCardKeys: ");
+                    PR_fprintf(PR_STDERR, "%s\n", ex.what() == NULL ? "null" : ex.what());
+                    goto done;
+                }catch(...){
+                    PR_fprintf(PR_STDERR, "DiversifyKey old key NistSP800_108KDF code: Unknown exception invoking NistSP800_108KDF::ComputeCardKeys.\n");
+                    goto done;
+                }
+
+            // if not a key version where we use the NIST SP800-108 KDF, use the original KDF
             }else{
-                context_jbyte = kddValue;
-                context_len_jsize = kddValue_len;
-            }
 
-            // Converting this way is safe since jbyte is guaranteed to be 8 bits
-            // Of course, this assumes that "char" is 8 bits (not guaranteed, but typical),
-            //            but it looks like this assumption is also made in GetDiversificationData
-            const BYTE* const context = reinterpret_cast<const BYTE*>(context_jbyte);
+                PR_fprintf(PR_STDOUT,"DiversifyKey old key NistSP800_108KDF code: Using original KDF for old keyset.\n");
 
-            // Convert jsize to size_t
-            const size_t context_len = static_cast<size_t>(context_len_jsize);
-            if (context_len > 0x000000FF){  // sanity check (CUID should never be larger than 255 bytes)
-                PR_fprintf(PR_STDERR, "DiversifyKey old key NistSP800_108KDF code: Error; context_len larger than 255 bytes.\n");
-                goto done;
-            }
+                // AC: Derives the kek key for the token.
+                old_kek_sym_key = ComputeCardKeyOnToken(oldMasterKey,KDCkek,1);
 
-            // call NIST SP800-108 KDF routine
-            try{
-                NistSP800_108KDF::ComputeCardKeys(oldMasterKey, context, context_len, &old_enc_sym_key, &old_mac_sym_key, &old_kek_sym_key);
-            }catch(std::runtime_error& ex){
-                PR_fprintf(PR_STDERR, "DiversifyKey old key NistSP800_108KDF code: Exception invoking NistSP800_108KDF::ComputeCardKeys: ");
-                PR_fprintf(PR_STDERR, "%s\n", ex.what() == NULL ? "null" : ex.what());
-                goto done;
-            }catch(...){
-                PR_fprintf(PR_STDERR, "DiversifyKey old key NistSP800_108KDF code: Unknown exception invoking NistSP800_108KDF::ComputeCardKeys.\n");
-                goto done;
-            }
+            } // endif use original KDF
+        }
 
-        // if not a key version where we use the NIST SP800-108 KDF, use the original KDF
-        }else{
+    }  else if(protocol == 2) {
 
-            PR_fprintf(PR_STDOUT,"DiversifyKey old key NistSP800_108KDF code: Using original KDF for old keyset.\n");
+            Buffer dek_key_buf    =   Buffer((BYTE*)old_kek_key, 16);
 
-            // AC: Derives the kek key for the token.
-            old_kek_sym_key = ComputeCardKeyOnToken(oldMasterKey,KDCkek);
+            PR_fprintf(PR_STDOUT,"DiversifyKey: protocol is 2 import wrapped dek key. \n");
+            dek_key_buf.dump();
+            transportKey = ReturnSymKey( slot, GetSharedSecretKeyName(NULL));
 
-        } // endif use original KDF
-        // ---------------------------------
+            if(transportKey == NULL)
+                goto done;
+
+            /* convert 16-byte to 24-byte triple-DES key */
+            memcpy(scp02DekKeyData, old_kek_key, 16);
 
+            old_kek_sym_key = UnwrapWrappedSymKeyOnToken( slot, transportKey,DES2_LENGTH, scp02DekKeyData,PR_FALSE);
 
+        } else {
+            PR_fprintf(PR_STDERR,"DiversifyKey: invalid protocol! \n");
+           goto done;
+
+        }
         // AC KDF SPEC CHANGE: Moved this code down so we don't skip it during "goto done".
         //if (oldMasterKey) {
         //    PK11_FreeSymKey( oldMasterKey );
         //    oldMasterKey = NULL;
         //}
-    }
 
     // AC KDF SPEC CHANGE: Moved this code down so we don't skip it during "goto done".
     //if(oldMasterKeyNameChars) {
@@ -1406,7 +1480,6 @@ extern "C" JNIEXPORT jbyteArray JNICALL Java_com_netscape_symkey_SessionKey_Dive
     } else {
         PR_fprintf(PR_STDOUT,"DiversifyKey: Compute card key on token case ! \n");
 
-
         // ---------------------------------
         // AC KDF SPEC CHANGE: Determine which KDF to use.
         //
@@ -1457,14 +1530,13 @@ extern "C" JNIEXPORT jbyteArray JNICALL Java_com_netscape_symkey_SessionKey_Dive
 
             // AC: Derives the kek key for the token.
             /* compute card key */
-            encKey = ComputeCardKeyOnSoftToken(masterKey, KDCenc);
-            macKey = ComputeCardKeyOnSoftToken(masterKey, KDCmac);
-            kekKey = ComputeCardKeyOnSoftToken(masterKey, KDCkek);
+            encKey = ComputeCardKeyOnSoftToken(masterKey, KDCenc,protocol);
+            macKey = ComputeCardKeyOnSoftToken(masterKey, KDCmac,protocol);
+            kekKey = ComputeCardKeyOnSoftToken(masterKey, KDCkek,protocol);
 
         } // endif use original KDF
         // ---------------------------------
 
-
         /* Fixes Bugscape Bug #55855: TKS crashes if specified key
          * is not present -- for each portion of the key, check if
          * the PK11SymKey is NULL before sending it to PK11_GetKeyData()!
@@ -1487,19 +1559,24 @@ extern "C" JNIEXPORT jbyteArray JNICALL Java_com_netscape_symkey_SessionKey_Dive
     }
 
     if (old_kek_sym_key != NULL) {
+        transportKey = ReturnSymKey( slot, GetSharedSecretKeyName(NULL));
+
         CreateKeySetDataWithSymKeys(newMasterKeyBuffer, Buffer(),
             old_kek_sym_key,
             encKey,
             macKey,
             kekKey,
+            protocol,
             output); }
     else {
         old_kek_sym_key =  ReturnDeveloperSymKey(slot, (char *) "kek", keySetString, old_kek_key_buff);
+
         CreateKeySetDataWithSymKeys(newMasterKeyBuffer, Buffer(),
             old_kek_sym_key,
             encKey,
             macKey,
             kekKey,
+            protocol,
             output);
     }
 
@@ -1628,6 +1705,101 @@ done:
     }
 }
 
+// Unwrap previously wrapped sym key. Assume the final output is 24 bytes DES3
+
+PK11SymKey *UnwrapWrappedSymKeyOnToken( PK11SlotInfo *slot, PK11SymKey * unWrappingKey,int sizeOfWrappedKey, unsigned char * wrappedKeyData, PRBool isPerm) {
+
+    PK11SymKey * unWrappedSymKey = NULL;
+    int final_len = DES3_LENGTH;
+    SECItem unWrappedKeyItem = { siBuffer, NULL, 0};
+    PK11SymKey *unwrapper = NULL;
+    PK11SymKey *unwrapped24Key = NULL;
+
+
+    PR_fprintf( PR_STDOUT,
+        "Creating UnWrappedSymKey on  token. UnwrapWrappedSymKeyOnToken.  \n");
+
+    if ( (slot == NULL) || (unWrappingKey == NULL) || (wrappedKeyData == NULL)) 
+    {
+        return NULL;
+    }
+
+    if(sizeOfWrappedKey == DES2_LENGTH) {
+       PR_fprintf( PR_STDOUT,
+        "UnwrapWrappedSymKeyOnToken . Given 16 byte encrypted key will have to derive a 24 byte on later. \n");
+   }
+
+   PK11SlotInfo *unwrapKeySlot = PK11_GetSlotFromKey( unWrappingKey );
+
+   if ( unwrapKeySlot != slot ) {
+       unwrapper =  PK11_MoveSymKey ( slot, CKA_ENCRYPT, 0, PR_FALSE, unWrappingKey);
+   }
+
+   SECItem *SecParam = PK11_ParamFromIV(CKM_DES3_ECB, NULL);
+   if ( SecParam == NULL) {
+       goto done;
+   }
+
+   if ( final_len != DES3_LENGTH ) {
+       goto done;
+   }
+
+   unWrappedKeyItem.data = wrappedKeyData;
+   unWrappedKeyItem.len  = sizeOfWrappedKey;
+
+   /* Now try to unwrap our key into the token */
+   unWrappedSymKey = PK11_UnwrapSymKeyWithFlagsPerm(unwrapper ? unwrapper : unWrappingKey,
+                          CKM_DES3_ECB,SecParam, &unWrappedKeyItem,
+                          CKM_DES3_ECB,
+                          CKA_UNWRAP,
+                          sizeOfWrappedKey, 0, isPerm );
+
+  if(unWrappedSymKey == NULL) {
+       PR_fprintf( PR_STDERR,
+        "UnwrapWrappedSymKeyOnToken . Unable to unwrap key onto token!. \n");
+       goto done;
+   }
+
+   if(sizeOfWrappedKey == DES2_LENGTH) {
+       unwrapped24Key = CreateDesKey24Byte(slot, unWrappedSymKey);
+       if(unwrapped24Key == NULL) {
+           PR_fprintf( PR_STDERR,
+        "UnwrapWrappedSymKeyOnToken . Unable to unwrap 24 byte key onto token!. \n");
+
+       }
+   }
+
+done:
+
+    if( SecParam != NULL ) {
+        SECITEM_FreeItem(SecParam, PR_TRUE);
+        SecParam = NULL;
+    }
+
+    if( unwrapper != NULL ) {
+        PK11_FreeSymKey( unwrapper );
+        unwrapper = NULL;
+    }
+
+    if( unwrapKeySlot != NULL) {
+        PK11_FreeSlot( unwrapKeySlot);
+        unwrapKeySlot = NULL;
+    }
+
+    if( unwrapped24Key != NULL) {
+        PK11_FreeSymKey( unWrappedSymKey);
+        unWrappedSymKey = unwrapped24Key;
+    }
+
+    PR_fprintf( PR_STDOUT,
+        "UnwrapWrappedSymKey on token result: %p \n",unWrappedSymKey);
+
+
+    return unWrappedSymKey;
+
+}
+
+
 PK11SymKey *CreateUnWrappedSymKeyOnToken( PK11SlotInfo *slot, PK11SymKey * unWrappingKey, BYTE *keyToBeUnWrapped, int sizeOfKeyToBeUnWrapped, PRBool isPerm)
 {
     PK11SymKey * unWrappedSymKey = NULL;
@@ -1675,6 +1847,10 @@ PK11SymKey *CreateUnWrappedSymKeyOnToken( PK11SlotInfo *slot, PK11SymKey * unWra
         goto done;
     }
 
+     PR_fprintf( PR_STDOUT,
+        "Creating UnWrappedSymKey on  token. final len %d \n", final_len);
+
+
     if ( final_len != DES3_LENGTH ) {
         goto done;
     }
@@ -1735,6 +1911,8 @@ PK11SymKey *ReturnDeveloperSymKey(PK11SlotInfo *slot, char *keyType, char *keySe
 
     snprintf(devKeyName,maxKeyNameSize,"%s-%sKey", keySet, keyType);
 
+    PR_fprintf(PR_STDOUT,"ReturnDeveloperSymKey! trying to find key %s. \n",devKeyName);
+
     devSymKey = ReturnSymKey( slot, devKeyName );
  
     // Try to create the key once and leave it there. 
@@ -1767,7 +1945,10 @@ PK11SymKey *ReturnDeveloperSymKey(PK11SlotInfo *slot, char *keyType, char *keySe
                     PR_fprintf(PR_STDERR, "Can't set the nickname of just written devKey! \n");
                 }
             }
+        } else {
+             PR_fprintf(PR_STDOUT,"ReturnDeveloperSymKey! input key size %d. \n",inputKey.size());
         }
+
     }
 
 done:
@@ -1806,3 +1987,20 @@ JNICALL Java_com_netscape_symkey_SessionKey_SetDefaultPrefix(JNIEnv * env, jclas
 
     return;
 }
+
+int checkForDeveloperKeySet(char * keyInfo) 
+{
+
+    if(keyInfo == NULL)
+        return 1;   
+
+    //SCP01 or SCP02
+    if(strcmp( keyInfo, "#01#01") == 0 || strcmp( keyInfo, "#FF#01") == 0)
+        return 1; 
+           
+    //SCP02 
+    if(strcmp( keyInfo, "#01#02") == 0 || strcmp( keyInfo, "#FF#02") == 0) 
+        return 1; 
+
+    return  0;
+}
diff --git a/base/symkey/src/com/netscape/symkey/SymKey.h b/base/symkey/src/com/netscape/symkey/SymKey.h
index efe1870..4f1bbe7 100644
--- a/base/symkey/src/com/netscape/symkey/SymKey.h
+++ b/base/symkey/src/com/netscape/symkey/SymKey.h
@@ -41,13 +41,14 @@ extern char sharedSecretSymKeyName[KEYNAMELENGTH];
 void GetDiversificationData(jbyte *cuidValue,BYTE *KDC,keyType keytype);
 PK11SymKey * ReturnSymKey( PK11SlotInfo *slot, char *keyname);
 void GetKeyName(jbyte *keyVersion,char *keyname);
-PK11SymKey * ComputeCardKeyOnToken(PK11SymKey *masterKey, BYTE* data);
+PK11SymKey * ComputeCardKeyOnToken(PK11SymKey *masterKey, BYTE* data,int protocol);
 PRStatus EncryptData(const Buffer &kek_key, PK11SymKey *card_key, Buffer &input, Buffer &output);
 PK11SlotInfo *ReturnSlot(char *tokenNameChars);
-PK11SymKey *ComputeCardKey(PK11SymKey *masterKey, unsigned char *data, PK11SlotInfo *slot);
+PK11SymKey *ComputeCardKey(PK11SymKey *masterKey, unsigned char *data, PK11SlotInfo *slot,int protocol);
 PK11SymKey *CreateUnWrappedSymKeyOnToken( PK11SlotInfo *slot, PK11SymKey * unWrappingKey, BYTE *keyToBeUnWrapped, int sizeOfKeyToBeUnWrapped, PRBool isPerm);
 PK11SymKey *ReturnDeveloperSymKey(PK11SlotInfo *slot, char *keyType, char *keySet, Buffer &inputKey);
 PK11SymKey *CreateDesKey24Byte(PK11SlotInfo *slot, PK11SymKey *origKey);
+PK11SymKey *UnwrapWrappedSymKeyOnToken( PK11SlotInfo *slot, PK11SymKey * unWrappingKey,int sizeOfWrappedKey, unsigned char * wrappedKeyData, PRBool isPerm);
 
 char *GetSharedSecretKeyName(char *newKeyName);
 
